#include <bits/stdc++.h>
using namespace std;

// a=97

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, k; cin >> n >> k;
    string s; cin >> s;
    vector<int64_t> ucestalost (k);
    for(int i=0; i<n; i++){
        ucestalost[(int)s[i]-97]++;
        int64_t mini = 1e9;
        for(const int& u : ucestalost) mini = min(mini, u);
        cout << mini+1 << ' ';
    }

}